export declare class DecoratorUtil {
    /**
     * create param decorators
     * @param value the value for the decorator
     * @param key the key under wich the value is saved
     * @returns the decorated function
     */
    static createParamDecorator(value: string, key: string): (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
    /**
     * create decorators for the class or for a method
     * @param key he key under wich the value is saved
     * @param value the value for the decorator
     * @returns the decorated function
     */
    static decorateClassOrMethod(key: string, value: any): (target: Object, propertyKey: string, descriptor: PropertyDescriptor) => void;
}
